/* $Id: mga2x64_main.h,v 1.4 1998/11/02 04:39:03 brian Exp $
******************************************************************************

   Matrox Millennium (mga2064w) -- special structures

   Copyright (C) 1997		Jonas Borgstrm
   Copyright (C) 1997		Hartmut Niemann
   Copyright (C) 1997           Matthias Grimrath

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef _MGA2064_MAIN_H_
#define _MGA2064_MAIN_H_

struct chipset_private
{
	struct common_private cp;

	kgiu8    interleave;
};

/* textmemory layout of the Millennium I/II framebuffer */

#ifdef DRIVER_mga2064 /* Millennium I */
typedef struct mgatext {
	kgiu16 ca;
	kgiu8 pad2_7[6];
} mgatext;
#elif DRIVER_mga2164 /* Millennium II */
typedef struct mgatext {
	kgiu16 ca;
	kgiu8 font1;
	kgiu8 pad3_9[7];
	kgiu8 font2;
	kgiu8 pad11_15[5];
} mgatext;
#else
#warning Unknown chip id, struct mgatext will be undefined!
#endif

#define MGA_INTERLEAVE (private->interleave)

void DAC_out8(struct kgi_display *dpy, kgiu8 val, kgiu8 reg);
kgiu8 DAC_in8(struct kgi_display *dpy, kgiu8 reg);

#endif /* _MGA2064_MAIN_H_ */
